"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNestedValue = undefined;
exports.getFieldsValue = getFieldsValue;

var _is_js = require("is_js");

var _is_js2 = _interopRequireDefault(_is_js);

var _helpers = require("./helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/prefer-default-export */
var getNestedValue = exports.getNestedValue = function getNestedValue(key, obj) {
  return key.split('.').reduce(function (result1, key1) {
    return result1[key1];
  }, obj);
};

function getCollectValues(collectSchema, state) {
  var fieldsToCollect = Object.keys(collectSchema);
  var result = {};

  fieldsToCollect.forEach(function (fieldName) {
    result[fieldName] = getNestedValue(collectSchema[fieldName], state);
  });

  return result;
}

function getFieldsValue(schema, state) {
  var mustOK = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

  var fieldNames = Object.keys(schema);
  var result = {};

  if (_is_js2.default.propertyDefined(schema, 'collectValues')) {
    result = getCollectValues(schema.collectValues, state);
  }

  fieldNames.forEach(function (name) {
    if (_is_js2.default.not.propertyDefined(state, name)) {
      // eslint-disable-next-line no-console
      console.warn("[veasy]: No " + name + " found in state.");
      return;
    }
    var fieldState = state[name];
    if (mustOK && fieldState.status !== _helpers.FieldStatus.ok) return;
    result[name] = fieldState.value;
  });

  return result;
}
//# sourceMappingURL=collectValuesUtils.js.map